#include <math.h>
#include <iostream.h>
#include "record.h"

const Real DECAY=1.01;		// decay speed this much each timestep
const Real KEYPRESS=10;	// add this much for a keypress.





Recorder::Recorder(int l)
    : intervals (l)
{

}

void
Recorder::process_breaks(unsigned int d, bool newkey)
{
    for (int i=0; i < breaks_.sz(); i++) {
	if (d > breaks_[i]->duration_)
	    sofar_[i] =0;
	else if (newkey)
	    sofar_[i]++;
    }	
}
int
Recorder::getsofar(const Break *b)const
{
    for (int i=0; i < breaks_.sz(); i++)
	if (breaks_[i] == b)
	    return sofar_[i];
    return 0;
}
	   
void
Recorder::record( XKeyEvent &event, unsigned int otherclock ) {
    XKeyEvent *k=&event;
    if (!intervals.end) { // no first keypress yet...
	lasttime = k->time-1000;
    }
    unsigned delta =  k->time-lasttime;    
    lasttime += delta;
    // don't count repeating keys
    if ( lastcod == k->keycode &&delta < 100  ) {
	return;
    }

    lastcod = k->keycode;
    last_programclock = otherclock;
    intervals.add(delta);
    process_breaks(delta);
}


void
Recorder::update( unsigned progclock) {    
    if (!intervals.end)  // no first keypress yet...
	return; 
        
    int delta =  progclock - last_programclock;       
    process_breaks(delta, false);
    intervals.last() = delta;
}

/// speed in chars / second
float
Recorder::getspeed() const
{
    Real t=0.0;
    if (!intervals.end)
	return 0;
    for (int  i=0; i < intervals.end; i ++)
	t+=intervals[i];
    Real spd =    intervals.end*1000/t;

    return spd;
}

void
Recorder::resetBreak(const Break*b)
{
   for (int i=0; i < breaks_.sz(); i++)
	if (breaks_[i] == b)
	    sofar_[i]=0;
}


